#!/usr/bin/perl -w
#
# Sort and organize file lists for publishing.
# By Russ Johnson 5/20/2000

# Location and name of raw list 
$infile = "/home/bbbs/work/tickinfo.txt";

# Delete the raw list?
# If you don't let this script do it, then you need to take care of it.
# Otherwise, you'll end up with multiple posts with the same files listed.
# "yes" deletes, anything else doesn't. <G>
$infiledel = "no";

# Name and Location of header file (optional)
$header = "/home/bbbs/tickhead.txt";

# Name and Location of fileecho description list (optional)
$echodescfile = "/home/ftp/pub/filebone/FILEBONE.NA";

# Where to put output files
$outdir = "/home/bbbs/work/out";

# Where BBBS is installed (optional)
# If this is defined, you must also define the following 4
$bbbsdir = "/home/bbbs";

# Echo area to post message in
$echoarea = "local.pdx.tick";

# Who you want messages to be "From:"
$sysop = "Russ Johnson";

# Who you want messages to be "To:"
$to = "All file hounds!";

# Default subject of file announcements
$defaultsubject = "Files received at Dimension 7!";

#######################################
# Don't modify below this line
#######################################

&readfile();

&splitlist();

&post();

&deleteinfile();

#######################################
# Subroutines
#######################################
# Read new filelist
#######################################

sub readfile
{
	$count = "0";
	$line = "1";
	
	open (FILE, "$infile") || die "Failed to open $infile: $!";
	
	while (<FILE>)
	{
		#chomp;
		
		if ($_ =~ /^ File\:/)
		{
			if ($count > "0")
			{
				$enddesc[$count] = $line;
			}
			
			$count++;
			
			$file[$count] = $_;
		}
		else
		{
			$desc[$line] = $_;
			
			$line++;
		}
	}
	
	close (FILE);
}

#######################################
# Split lists
#######################################

sub splitlist
{
	$number = $count;
	
	$count = "1";
	$line = "0";
	
	until ($count == $number)
	{
		&printfile();
		
		&printdesc();
		
		$count++;
	}
}

#######################################
# Write the file
#######################################

sub printfile
{
	$startarea = (index $file[$count], Area) + 6;
	$endarea = (index $file[$count], ",", $startarea) - $startarea;
	$areaname = substr($file[$count], $startarea, $endarea);
	
	$areaname =~ tr/[A-Z]/[a-z]/;
	
	if (open (OUT, "$outdir/$areaname"))
	{
		close OUT;
		
		open (OUT, ">>$outdir/$areaname") || die "Can't open $areaname: $!";
		
		print OUT "$file[$count]";
	}
	else
	{
		close OUT;
		
		open (OUT, ">>$outdir/$areaname") || die "Can't open $areaname: $!";
		
		&writeheader();
		
		print OUT "$file[$count]";
	}
}

#######################################
# Write the whole description
#######################################

sub printdesc
{
	print OUT "$desc[$line]" until (++$line == $enddesc[$count]);

	$line--;
}

#######################################
# Write area description the first time through
#######################################

sub writeheader
{
	if (!defined $header || $header eq "")
	{
	print OUT "    This is a  list of the files recently received in the fileecho $areaname.\n
	They are available for download or file request from this server.\n
	=================================================================\n\n"
	}
	else
	{
		open (HEAD, "$header") || die "Can't open file $header: $!";
		
		while (<HEAD>)
		{
			chomp;
			
			# Need to translate tags to proper strings here
			if (/\bAREA\b/)
			{
				s/\bAREA\b/$areaname/g;
			}	
						
			print OUT "$_\n";
		}
		
		close HEAD;
	}
}

#######################################
# Post list to bbs
#######################################

sub post
{
	opendir(OUTDIR, $outdir) || die "Can't open directory $outdir: $!";
	@files = readdir(OUTDIR);
	closedir(OUTDIR);
	
	foreach $file (@files)
	{
		if ($file =~ /[a-z]/)
		{
			
			undef $echodesc;
			
			&areadescription ($file);	
			
			if (defined $echodesc)
			{
				$subject = "Files received in: $echodesc";
			}
			else
			{
				$subject = $defaultsubject;
			}
			
			system "$bbbsdir/bbbs btxt2bbs $echoarea $outdir/$file /F $sysop /T $to /S '$subject'";
			
			unlink("$outdir/$file") || die "Unable to delete $file: $!";
		}
	}
}



#######################################
# Get area description
# Required parameters: area to look for
#######################################

sub areadescription
{
	if (defined $echodescfile)
	{
		open(DESC, "$echodescfile") || die "Can't open $echodescfile: $!";
		
		while (<DESC>)
		{
			chomp;
			
			if (/$_[0]/i && !/^%/)
			{
				$startdesc = (rindex $_, "  " ) + 2;
				
				$echodesc = substr($_, $startdesc);
			}
		}
		
		close(DESC);
	}
}

#######################################
# Delete inputfile
#######################################

sub deleteinfile
{
	if ($infiledel eq "yes")
	{
		unlink("$infile") || die "Unable to delete $infile: $!";
	}
}